/* ******************************************************************************

	FILE:			SSUtils.h
	AUTHOR:			Jean-Sbastien Perrier

	DESCRIPTION:	This file contains a collection of utility classes and
					functions usefull for a screen saver application.

	$History::                                                                  $

****************************************************************************** */
#ifdef _MSC_VER
	#pragma once
#endif
#ifndef SSUTILS_H
#define SSUTILS_H

// Includes ****************************************************************** //

// Defines ******************************************************************* //

// Types ********************************************************************* //

////////////////////////////////////////////////////////////////////////////////
// CLASS:			SSUtlReg
// INHERITS FROM:	None
// DESCRIPTION:		Utility class to encapsluate the ugly windows registry 
//					management code.
// REMARKS:			None
////////////////////////////////////////////////////////////////////////////////
class SSUtlReg
{
private:
	HKEY m_hKey;
public:
	bool Open(const char *a_szPath);	// Open a key
	bool Create(const char *a_szPath);	// Create a key
	void Close();						// Close the key

	DWORD ReadDWord(const char *a_szKey, DWORD a_dwDefault);
	bool WriteDWord(const char *a_szKey, DWORD a_dwValue);
	bool ReadString(const char *a_szKey, char *a_szString, int a_nDim);
	bool WriteString(const char *a_szKey, const char *a_szString);
};

////////////////////////////////////////////////////////////////////////////////
// CLASS:			SSClock
// INHERITS FROM:	None
// DESCRIPTION:		Utility class to encapsulate the performance counter code
//					and provide a simple interface to get the current time.
// REMARKS:			None
////////////////////////////////////////////////////////////////////////////////
class SSClock
{
private:
	static float s_fPeriod;
public:
	static void Init();
	static float GetTime();
};

// Consts ******************************************************************** //

// Globals ******************************************************************* //

// Static Members Storage Point ********************************************** //

// Function Prototypes ******************************************************* //

// -- Screen saver password stuff --
BOOL SSUtl_VerifyPassword(HWND hwnd);
void SSUtl_ChangePassword(HWND hwnd);
// -- Argument parser (similar to strok but doesn't use global var.) --
char *SSUtl_GetArg(char *a_szString, char *a_szDest, const char *a_szDelimiters);

// Module External Functions ************************************************* //

// Module Internal Functions ************************************************* //

#endif //SSUTILS_H